%define pkgname		util-linux
%define pkgmount	mount
%define pkgbsdutils	bsdutils
%define targetroot 	%{_hhl_cross_target_dir}
%define _bindir		%{targetroot}%{_hhl_target_bin_dir}
%define _sbindir	%{targetroot}%{_hhl_target_sbin_dir}
%define _etcdir		%{targetroot}%{_hhl_target_sysconf_dir}
%define _libdir		%{targetroot}%{_hhl_target_lib_dir}
%define _datadir	%{targetroot}%{_hhl_target_sharedstate_dir}
%define _mandir		%{targetroot}%{_hhl_target_man_dir}
%define _infodir	%{targetroot}%{_hhl_target_info_dir}
%define _docdir		%{targetroot}%{_hhl_target_doc_dir}

Summary		: Miscellaneous system utilities.
Name		: util-linux
Version		: 2.12r
Release		: 3.0.0.%{_hhl_build_id}
License		: GPL/BSD
Group		: base
Source		: util-linux_%{version}.orig.tar.gz
Patch0		: util-linux_%{version}-2.diff.gz
Patch1		: util-linux-initd.diff
# 		The follow patch allows /dev/console to be used on the getty w/o passing 
# 		in a baud rate.
Patch2		: util-linux-2.12-agetty.patch
# 		Add xtensa support.
Patch3		: mvl-util-linux-xtensa.patch
# 		The following patches allow for umount to know about forced unmount
# 		capability
Patch4		: fumount-1.patch
# 		Remove unnecisary code that was causing issues with HA code.
Patch5		: util-linux-2.12-fdisk.patch
# 		Add mips64 to the list of 64 bit arches, in some places.
Patch6		: util-linux-mips64.patch
# 		Another cross-compile issue.
Patch7		: util-linux-2.12-swapon.patch
Patch8		: util-linux-2.12-init.patch
#		PAGE_SHIFT / PAGE_SIZE cannot be relied upon.
Patch9		: util-linux-2.12-no_page_shift.patch
#		Fixes partition limits on SCSI disk
Patch10		: util-linux-fdisk-SCSI.patch
#		Fixes PAGE_CACHE_SIZE in disk-utils/fsck.cramfs.c
Patch12		: fix-util-linux-page-cache-size.patch
#		Fix umount issue led by symbol link resolving
Patch13		: fix-umount-issue-led-by-symbol-link-resolve.patch
#               Support for -x option that creates XIP cramfs Images.
Patch14         : util-linux-2.12-xip.patch
Patch15		: util-linux_2.12r-2.6.18-kh.diff
Patch16		: util-linux-2.12-successonfail.diff
BuildRoot	: %{_tmppath}/%{name}-%{_hhl_target_arch}-root
Prefix		: %{targetroot}
Obsoletes 	: hhl-target-util-linux
Obsoletes 	: hhl-%{_hhl_target_arch}-util-linux

%description

 A mixed bag of system utilities: arch blockdev chkdupexe cfdisk cytune
 dmesg fdisk fsck.minix getty getopt hwclock ipcrm ipcs mcookie mkfs
 mkfs.minix mkfs.cramfs mkswap more namei pivot_root raw setterm setsid
 tunelp whereis.


%package -n %{pkgmount}
Summary		: Tools for mounting and manipulating filesystems.
Group		: base
Obsoletes 	: hhl-%{_hhl_target_arch}-mount

%description -n %{pkgmount}

 This package provides the mount(8), umount(8), swapon(8),
 swapoff(8), and losetup(8) commands.


%package -n %{pkgbsdutils}
Summary		: Basic utilities from 4.4BSD-Lite.
Group		: base
Obsoletes 	: hhl-%{_hhl_target_arch}-bsdutils

%description -n %{pkgbsdutils}

 This package contains the bare minimum number of BSD utilities needed
 to boot a system. 

 Included are: logger, renice, script, wall, kill


%prep
%target_check
%setup -q -n util-linux-%{version}
%patch0 -p1

#apply debian/patches
%{_mvl_apply_dpatch}

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1

%build
%target_setup
./configure
%if "%{_mvl_uclibc}" == "yes"
%make CPU=%{_hhl_target_cpu} ADD_RAW=yes HAVE_SLANG=no OPT="-O2 -pipe -fno-unit-at-a-time -DTTY_NAME_MAX=32" HAVE_XGETTEXT="yes"
%else
%make CPU=%{_hhl_target_cpu} ADD_RAW=yes HAVE_SLANG=no OPT="-O2 -pipe -fno-unit-at-a-time "
%endif

%install
%target_setup
rm -rf %{buildroot}

for i in %{_bindir} %{_sbindir} %{_etcdir}/init.d %{_libdir}/mime/packages \
	%{_datadir} %{targetroot}/{bin,sbin} %{_mandir}/man{1,5,8} %{_infodir}
do
    install -d %{buildroot}$i
done

# It is too complicated to use the builtin makefile, so we install manually

# Following is the main util-linux files
# INITFILES
install -m 755 debian/hwclock.sh \
	%{buildroot}%{_etcdir}/init.d/hwclock.sh

# BINFILES
install -m 755 misc-utils/kill sys-utils/{arch,dmesg} text-utils/more \
	%{buildroot}%{targetroot}/bin/
install -m 755 text-utils/col \
        %{buildroot}%{targetroot}/usr/bin/

# SBINFILES
install -m 755 disk-utils/{mkswap,blockdev} login-utils/agetty \
	hwclock/hwclock \
	%{buildroot}%{targetroot}/sbin/

# SBINFILES (2.4 kernel)
install -m 755 disk-utils/raw mount/pivot_root \
	%{buildroot}%{targetroot}/sbin/

# UBINFILES
install -m 755 sys-utils/{ipcs,ipcrm,setsid} \
	misc-utils/{namei,setterm,mcookie,whereis,ddate} \
	getopt/getopt text-utils/rev disk-utils/fdformat \
	%{buildroot}%{_bindir}/

# UBINFILES2
install -m 755 misc-utils/chkdupexe \
	%{buildroot}%{_bindir}/

# USBINFILES
install -m 755 sys-utils/readprofile disk-utils/elvtune \
	%{buildroot}%{_sbindir}/

# Following is the Mount Package files
# MOUNTBINFILES
install -m 4755 mount/mount mount/umount \
	%{buildroot}%{targetroot}/bin/

# MOUNTSBINFILES
install -m 755 mount/swapon mount/losetup \
	%{buildroot}%{targetroot}/sbin/

# Following is the bsd-utils files
# BSDUBINFILES
install -m 755 misc-utils/script misc-utils/logger sys-utils/renice \
	%{buildroot}%{_bindir}/

# BSDMAN1FILES
install -m 644 login-utils/wall.1 misc-utils/script.1 misc-utils/logger.1 \
	%{buildroot}%{_mandir}/man1/

# BSDMAN8FILES
install -m 644 sys-utils/renice.8 \
	%{buildroot}%{_mandir}/man8/

# BSDDOCFILES [ignored]

# MAN1FILES 
install -m 644 text-utils/{more,rev}.1 misc-utils/{namei.1,mcookie.1} \
	sys-utils/{arch,readprofile}.1 \
	misc-utils/{chkdupexe.1,kill.1,setterm.1,whereis.1,ddate.1} \
	getopt/getopt.1 \
	%{buildroot}%{_mandir}/man1/

# MAN8FILES 
install -m 644 sys-utils/{dmesg.8,ipcrm.8,ipcs.8,setsid.8} \
	login-utils/agetty.8 \
	hwclock/hwclock.8 \
	disk-utils/{mkswap.8,blockdev.8} disk-utils/elvtune.8 \
	disk-utils/fdformat.8 \
	%{buildroot}%{_mandir}/man8/

# MAN8FILES (2.4 kernel)
install -m 644 disk-utils/raw.8 mount/pivot_root.8 \
	%{buildroot}%{_mandir}/man8/


# EXAMPLES [listed in %files section]

# INFOFILES
install -m 644 sys-utils/ipc.info \
	%{buildroot}%{_infodir}/


# DOCFILES [listed in %files section]

# MOUNTMAN5FILES
install -m 644 mount/fstab.5 mount/nfs.5 \
	%{buildroot}%{_mandir}/man5/

# MOUNTMAN8FILES
install -m 644 mount/losetup.8 mount/swapoff.8 mount/umount.8 \
	mount/mount.8 mount/swapon.8 \
	%{buildroot}%{_mandir}/man8/


# MOUNTDOCFILES [listed in %files section]

# Filesystem tools
# SBINFILES
install -m 755 disk-utils/{mkfs,mkfs.{minix,cramfs},fsck.{minix,cramfs}} \
	%{buildroot}%{targetroot}/sbin/
ln -sf /sbin/mkfs.cramfs %{buildroot}%{targetroot}/sbin/mkcramfs

# MAN8FILES
install -m 644 disk-utils/{{fsck,mkfs}.minix.8,mkfs.8} \
	%{buildroot}%{_mandir}/man8/

# Fdisk tools
# USBINFILES
install -m 755 sys-utils/{tunelp,cytune} \
	%{buildroot}%{_sbindir}/

# SBINFILES
install -m 755 fdisk/{cfdisk,fdisk,sfdisk} \
	%{buildroot}%{targetroot}/sbin/

# MAN8FILES
install -m 644 fdisk/{cfdisk.8,fdisk.8,sfdisk.8} \
	sys-utils/{tunelp.8,cytune.8} \
	%{buildroot}%{_mandir}/man8/


# DOCFILES [listed in %files section]

# We do not include rdev...

# install locale files
%if "%{_mvl_uclibc}" == "yes"
(cd po && make install HAVE_XGETTEXT="yes" DESTDIR=%{buildroot}%{targetroot})
%else
(cd po && make install DESTDIR=%{buildroot}%{targetroot})
%endif
# compress man pages
find %{buildroot}%{_infodir} -type f | xargs gzip -9f
find %{buildroot}%{_mandir} -type f | xargs gzip -9f

# getty is a special case
# In the past we called agetty "getty" so symlink it here.
ln -s agetty %{buildroot}%{targetroot}/sbin/getty
ln -s agetty.8.gz %{buildroot}%{_mandir}/man8/getty.8.gz

# install mime
install -m 644 debian/mime.util-linux \
	%{buildroot}%{_libdir}/mime/packages/util-linux

ln -s swapon %{buildroot}%{targetroot}/sbin/swapoff
ln -s hwclock.8.gz %{buildroot}%{_mandir}/man8/clock.8.gz
cp debian/copyright LICENSE

%clean
rm -rf %{buildroot}


%files -n %{pkgname}
%defattr(-,root,root)
%{_etcdir}/init.d/hwclock.sh
%{targetroot}/bin/arch
%{targetroot}/bin/dmesg
%{targetroot}/bin/more
%{targetroot}/sbin/mkswap
%{targetroot}/sbin/blockdev
%{targetroot}/sbin/agetty
%{targetroot}/sbin/getty
%{targetroot}/sbin/hwclock
%{targetroot}/sbin/raw
%{targetroot}/sbin/pivot_root
%{_bindir}/ipcs
%{_bindir}/ipcrm
%{_bindir}/setsid
%{_bindir}/namei
%{_bindir}/setterm
%{_bindir}/mcookie
%{_bindir}/whereis
%{_bindir}/ddate
%{_bindir}/getopt
%{_bindir}/rev
%{_bindir}/fdformat
%{_bindir}/chkdupexe
%{_sbindir}/readprofile
%{_sbindir}/elvtune
%{targetroot}/sbin/mkfs
%{targetroot}/sbin/mkfs.minix
%{targetroot}/sbin/mkfs.cramfs
%{targetroot}/sbin/fsck.minix
%{targetroot}/sbin/fsck.cramfs
%{targetroot}/sbin/mkcramfs
%{_sbindir}/tunelp
%{_sbindir}/cytune
%{targetroot}/sbin/cfdisk
%{targetroot}/sbin/fdisk
%{targetroot}/sbin/sfdisk
%{_mandir}/man1/more.1*
%{_mandir}/man1/kill.1*
%{_mandir}/man1/rev.1*
%{_mandir}/man1/namei.1*
%{_mandir}/man1/mcookie.1*
%{_mandir}/man1/arch.1*
%{_mandir}/man1/readprofile.1*
%{_mandir}/man1/chkdupexe.1*
%{_mandir}/man1/setterm.1*
%{_mandir}/man1/whereis.1*
%{_mandir}/man1/ddate.1*
%{_mandir}/man1/getopt.1*
%{_mandir}/man8/dmesg.8*
%{_mandir}/man8/ipcrm.8*
%{_mandir}/man8/ipcs.8*
%{_mandir}/man8/setsid.8*
%{_mandir}/man8/agetty.8*
%{_mandir}/man8/getty.8*
%{_mandir}/man8/clock.8*
%{_mandir}/man8/hwclock.8*
%{_mandir}/man8/mkswap.8*
%{_mandir}/man8/blockdev.8*
%{_mandir}/man8/elvtune.8*
%{_mandir}/man8/fdformat.8*
%{_mandir}/man8/raw.8*
%{_mandir}/man8/pivot_root.8*
%{_mandir}/man8/fsck.minix.8*
%{_mandir}/man8/mkfs.minix.8*
%{_mandir}/man8/mkfs.8*
%{_mandir}/man8/cfdisk.8*
%{_mandir}/man8/fdisk.8*
%{_mandir}/man8/sfdisk.8*
%{_mandir}/man8/tunelp.8*
%{_mandir}/man8/cytune.8*
%{_datadir}/locale/*/LC_MESSAGES/util-linux.mo
%{_libdir}/mime/packages/util-linux
%doc %{_infodir}/ipc.info*
%doc debian/fstab.example2 fdisk/sfdisk.examples
%doc getopt/getopt-test.bash getopt/getopt-test.tcsh
%doc getopt/getopt-parse.bash getopt/getopt-parse.tcsh
%doc README HISTORY login-utils/README.getty LICENSE
%doc login-utils/README.modems-with-agetty
%doc login-utils/README.poeigl
%doc fdisk/README.cfdisk fdisk/README.fdisk


%files -n %{pkgmount}
%defattr(-,root,root)
%attr(4755,root,root)	%{targetroot}/bin/mount
%attr(4755,root,root)	%{targetroot}/bin/umount
%{targetroot}/sbin/losetup
%{targetroot}/sbin/swapon
%{targetroot}/sbin/swapoff
%doc %{_mandir}/man5/fstab.5*
%doc %{_mandir}/man5/nfs.5*
%doc %{_mandir}/man8/losetup.8*
%doc %{_mandir}/man8/swapoff.8*
%doc %{_mandir}/man8/swapon.8*
%doc %{_mandir}/man8/mount.8*
%doc %{_mandir}/man8/umount.8*
%doc mount/README.mount debian/mount.fstab LICENSE


%files -n %{pkgbsdutils}
%defattr(-,root,root)
%{_bindir}/script
%{_bindir}/logger
%{_bindir}/renice
%{targetroot}/bin/kill
%{targetroot}/usr/bin/col
%doc %{_mandir}/man1/script.1*
%doc %{_mandir}/man1/logger.1*
%doc %{_mandir}/man1/wall.1*
%doc %{_mandir}/man8/renice.8*
%doc debian/README.script LICENSE

%changelog
* Fri Sep 23 2005 Yi Yang <yyang@ch.mvista.com>
- Update to 2.12p-8

* Thu Jun 17 2004 Tom Rini <source@mvista.com>
- Update to version 2.12
- Merge fumount and fumount-po into one patch.

* Thu Nov 13 2003 Daniel Jacobowitz <drow@mvista.com>
- Add support for MIPS64 architecture.

* Wed Nov 20 2002 Mark Huth <mhuth@mvista.com>
- Added Patch8 and Patch9 for fumount mods to umount utility

* Tue May 28 2002 Joe Green <source@mvista.com>
- Add support for Xtensa architecture.

* Fri Apr 20 2001 Automated script (run by Steve Kinneberg <source@mvista.com>)
- Added TCT package description files

* Tue Feb 27 2001 Matthew McLean <source@mvista.com>
- First cut
